MODULE Statistics;

IMPORT X:=ExNumbers, M:=ExMathLib0;

VAR
  x-, y-, Sumx-, Sumy-, Sumxy-, Sumx2-, Sumy2-, Meanx-, Meany-,
  SDevx-, SDevy-, Varx-, Vary-: X.ExNumType;
  n-: LONGINT;

PROCEDURE StdDev (VAR r: X.ExNumType; n, Sum2, Sum: X.ExNumType);
BEGIN
  X.ExMult(Sum, Sum, Sum);   (* Sum^2 *)
  X.ExMult(r, n, Sum2);      (* n*Sum2 *)
  X.ExSub(r, r, Sum);        (* n*Sum2 - Sum^2 *)
  M.sqrtX(r, r);
  X.ExDiv(r, r, n)
END StdDev;

PROCEDURE Addxy* (x1, y1: X.ExNumType);
VAR t: X.ExNumType;
BEGIN
  INC(n); X.ExAdd(Sumx, Sumx, x1); X.ExAdd(Sumy, Sumy, y1);
  X.ExMult(t, x1, y1); X.ExAdd(Sumxy, Sumxy, t);
  X.ExMult(t, x1, x1); X.ExAdd(Sumx2, Sumx2, t);
  X.ExMult(t, y1, y1); X.ExAdd(Sumy2, Sumy2, t);
  X.ExNumb(n, 0, 0, t);
  X.ExDiv(Meanx, Sumx, t); X.ExDiv(Meany, Sumy, t);
  StdDev(SDevx, t, Sumx2, Sumx); StdDev(SDevy, t, Sumy2, Sumy);
  X.ExMult(Varx, SDevx, SDevx); X.ExMult(Vary, SDevy, SDevy)
END Addxy;

PROCEDURE Clear*;
BEGIN
  x:=X.Ex0; y:=X.Ex0; Sumx:=X.Ex0; Sumy:=X.Ex0;
  Sumx2:=X.Ex0; Sumy2:=X.Ex0; Meanx:=X.Ex0; Meany:=X.Ex0;
  SDevx:=X.Ex0; SDevy:=X.Ex0; Varx:=X.Ex0; Vary:=X.Ex0;
  n:=0
END Clear;

BEGIN
  Clear
END Statistics.